![Tensorflow 2.4.1](https://img.shields.io/badge/Tensorflow-2.4.1-success.svg)
# Tensorflow 2 code for D2L book's Attention Mechanisms chapter

### **This code has been merged with D2L book. See PR: [1756](https://github.com/d2l-ai/d2l-en/pull/1756), [1768](https://github.com/d2l-ai/d2l-en/pull/1768)**

This repository contains `Tensorflow 2` code for Attention Mechanisms chapter of [Dive into Deep Learning (D2L)](http://d2l.ai/) book. The chapter has 7 sections and code for each section can be found at the following links.

[10.1. Attention Cues](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/10_1_Visualization_of_attention.ipynb)

[10.2. Attention Pooling: Nadaraya-Watson Kernel Regression](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/10_2_Attention_based_regression.ipynb)

[10.3. Attention Scoring Functions](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/10_3_Attention_scoring_functions.ipynb)

[10.4. Bahdanau Attention](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/10_4_Bahdanau_attention.ipynb)

[10.5. Multi-Head Attention](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/10_5_Multi-head_attention.ipynb)

[10.6. Self-Attention and Positional Encoding](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/10_6_Self-attention_and_positional_encoding.ipynb)

[10.7. Transformer](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/10_7_Transformer.ipynb)

### Additional sections:

[9.7. Sequence to Sequence Learning](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/additional_sections/9_7_Sequence_to_Sequence_Learning.ipynb)

[9.6. Encoder Decoder Architecture](https://github.com/biswajitsahoo1111/D2L_Attention_Mechanisms_in_TF/blob/master/additional_sections/9_6_Encoder_Decoder_Architecture.ipynb)

### Additional Chapters:

Chapter 17: [Generative Adversarial Networks](https://github.com/biswajitsahoo1111/D2L_Generative_Adversarial_Networks_in_TF)

### How to run these code:

The best way (in our opinion) is to either clone the repo (or download the zipped repo) and then run each notebook from the cloned (or extracted) folder. All the notebooks will run without any issue.

**Note**: We claim no originality for the code. Credit goes to the authors of this excellent [book](http://d2l.ai/). However, all errors and omissions are my own and readers are encouraged to bring it to my notice. Finally, no TF code was available (to the best of my knowledge) for `Attention Mechanisms` chapter when this repo was first made public.
